import { computed as g, ref as x, watch as P, onMounted as q, nextTick as H, openBlock as r, createElementBlock as v, normalizeStyle as p, unref as s, renderSlot as z, normalizeProps as L, mergeProps as X, createCommentVNode as d, createElementVNode as c, toDisplayString as f, Fragment as T, renderList as R, guardReactiveProps as J, createBlock as K } from "vue";
import { u as Q, c as Y, t as Z, a as ee, p as k, b as te, o as le, e as O, g as ae, d as oe, s as b, i as w, f as C, X as se, w as ue } from "./index-DI4DaxVG.js";
import { u as E } from "./useNestedProp-COsQo-tX.js";
import ne from "./vue-ui-skeleton-DH4t1hrL.js";
const ie = ["onClick"], re = { key: 1 }, ve = ["xmlns", "viewBox"], ce = ["id"], de = ["stop-color"], pe = ["stop-color"], fe = ["height", "width", "fill", "rx"], ye = ["height", "width", "fill", "rx"], me = ["height", "width", "fill", "rx"], we = {
  __name: "vue-ui-sparkbar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    /**
     * Used in VueUiRadar's tooltip exclusively
     */
    backgroundOpacity: {
      type: Number,
      default: 100
    }
  },
  emits: ["selectDatapoint"],
  setup(_, { emit: V }) {
    const a = _, { vue_ui_sparkbar: B } = Q(), $ = g(() => !!a.dataset && a.dataset.length), S = x(Y()), e = g({
      get: () => A(),
      set: (t) => t
    });
    function A() {
      const t = E({
        userConfig: a.config,
        defaultConfig: B
      });
      return t.theme ? {
        ...E({
          userConfig: Z.vue_ui_sparkbar[t.theme] || a.config,
          defaultConfig: t
        }),
        customPalette: ee[t.theme] || k
      } : t;
    }
    P(() => a.config, (t) => {
      e.value = A();
    }, { deep: !0 });
    const M = g(() => te(e.value.customPalette)), y = x(a.dataset.map((t) => ({
      ...t,
      value: e.value.style.animation.show ? 0 : t.value || 0,
      formatter: t.formatter || null
    }))), D = x(null);
    q(async () => {
      le(a.dataset) && O({
        componentName: "VueUiSparkbar",
        type: "dataset"
      }), F();
    });
    function F() {
      if (e.value.style.animation.show) {
        let I = function() {
          i += l / t, i < l ? (y.value = y.value.map((u, h) => ({
            ...u,
            value: u.value += o[h]
          })), D.value = requestAnimationFrame(I)) : y.value = a.dataset.map((u) => ({
            ...u,
            value: u.value || 0,
            formatter: u.formatter || null
          }));
        };
        const t = e.value.style.animation.animationFrames, o = a.dataset.map((u, h) => u.value / t), l = a.dataset.map((u) => u.value || 0).reduce((u, h) => u + h, 0);
        let i = 0;
        I();
      }
    }
    P(() => a.dataset, async (t) => {
      cancelAnimationFrame(D.value), y.value = a.dataset.map((o) => ({
        ...o,
        value: e.value.style.animation.show ? 0 : o.value || 0,
        formatter: o.formatter || null
      })), H(F);
    }, { deep: !0 });
    const n = x({
      width: 500,
      height: 16
    }), U = g(() => Math.max(...a.dataset.map((t) => t.value))), j = g(() => (a.dataset.forEach((t, o) => {
      ae({
        datasetObject: t,
        requiredAttributes: ["name", "value"]
      }).forEach((l) => {
        O({
          componentName: "VueUiSparkbar",
          type: "datasetSerieAttribute",
          property: l,
          index: o
        });
      });
    }), y.value.map((t, o) => ({
      ...t,
      value: t.value || 0,
      color: oe(t.color) || M.value[o] || k[o] || k[o % k.length]
    }))));
    function G(t) {
      return t / U.value;
    }
    function N(t) {
      return e.value.style.layout.independant ? t.target ? t.value / t.target : e.value.style.layout.percentage ? t.value > 100 ? 1 : t.value / 100 : e.value.style.layout.target === 0 ? 1 : t.value / e.value.style.layout.target : G(t.value);
    }
    function m(t) {
      return e.value.style.layout.independant && t.target || e.value.style.layout.target;
    }
    function W(t, o) {
      V("selectDatapoint", { datapoint: t, index: o });
    }
    return (t, o) => (r(), v("div", {
      style: p({
        width: "100%",
        fontFamily: e.value.style.fontFamily,
        background: s(b)(e.value.style.backgroundColor, a.backgroundOpacity)
      })
    }, [
      t.$slots.title ? z(t.$slots, "title", L(X({ key: 0 }, { title: { ...t.title, title: e.value.style.title.text, subtitle: e.value.style.title.subtitle.text } }))) : d("", !0),
      !t.$slots.title && e.value.style.title.text ? (r(), v("div", {
        key: 1,
        class: "vue-ui-sparkbar-title-container",
        style: p({
          background: e.value.style.title.backgroundColor,
          margin: e.value.style.title.margin,
          textAlign: e.value.style.title.textAlign
        })
      }, [
        c("div", {
          class: "vue-ui-sparkbar-title",
          style: p({
            fontSize: e.value.style.title.fontSize + "px",
            color: e.value.style.title.color,
            fontWeight: e.value.style.title.bold ? "bold" : "normal"
          })
        }, f(e.value.style.title.text), 5),
        e.value.style.title.subtitle.text ? (r(), v("div", {
          key: 0,
          class: "vue-ui-sparkbar-subtitle",
          style: p({
            fontSize: e.value.style.title.subtitle.fontSize + "px",
            color: e.value.style.title.subtitle.color,
            fontWeight: e.value.style.title.subtitle.bold ? "bold" : "normal"
          })
        }, f(e.value.style.title.subtitle.text), 5)) : d("", !0)
      ], 4)) : d("", !0),
      (r(!0), v(T, null, R(j.value, (l, i) => (r(), v(T, null, [
        $.value ? (r(), v("div", {
          key: 0,
          style: p(`display:flex !important;${["left", "right"].includes(e.value.style.labels.name.position) ? `flex-direction: ${e.value.style.labels.name.position === "right" ? "row-reverse" : "row"} !important` : "flex-direction:column !important"};gap:${e.value.style.gap}px !important;align-items:center;${_.dataset.length > 0 && i !== _.dataset.length - 1 ? "margin-bottom:6px" : ""}`),
          onClick: () => W(l, i)
        }, [
          z(t.$slots, "data-label", L(J({ bar: {
            ...l,
            target: m(l),
            valueLabel: s(w)(
              l.formatter,
              l.value,
              s(C)({
                p: l.prefix || "",
                v: l.value,
                s: l.suffix || "",
                r: l.rounding || 0
              }),
              { datapoint: l, seriesIndex: i }
            ),
            targetLabel: s(w)(
              l.formatter,
              m(l),
              s(C)({
                p: l.prefix || "",
                v: m(l),
                s: l.suffix || "",
                r: l.rounding || 0
              }),
              { datapoint: l, seriesIndex: i }
            )
          } }))),
          t.$slots["data-label"] ? d("", !0) : (r(), v("div", {
            key: 0,
            style: p({
              width: e.value.style.labels.name.width,
              color: e.value.style.labels.name.color,
              fontSize: e.value.style.labels.fontSize + "px",
              fontWeight: e.value.style.labels.name.bold ? "bold" : "normal",
              textAlign: ["left", "right"].includes(e.value.style.labels.name.position) || ["top", "top-left"].includes(e.value.style.labels.name.position) ? "left" : e.value.style.labels.name.position === "top-center" ? "center" : "right"
            })
          }, [
            c("span", null, f(l.name), 1),
            e.value.style.labels.value.show ? (r(), v("span", {
              key: 0,
              style: p(`font-weight:${e.value.style.labels.value.bold ? "bold" : "normal"}`)
            }, ": " + f(s(w)(
              l.formatter,
              l.value,
              s(C)({
                p: l.prefix || "",
                v: l.value,
                s: l.suffix || "",
                r: l.rounding || 0
              }),
              { datapoint: l, seriesIndex: i }
            )), 5)) : d("", !0),
            e.value.style.layout.showTargetValue ? (r(), v("span", re, f(" " + e.value.style.layout.targetValueText) + " " + f(s(w)(
              l.formatter,
              m(l),
              s(C)({
                p: l.prefix || "",
                v: m(l),
                s: l.suffix || "",
                r: l.rounding || 0
              }),
              { datapoint: l, seriesIndex: i }
            )), 1)) : d("", !0)
          ], 4)),
          (r(), v("svg", {
            xmlns: s(se),
            viewBox: `0 0 ${n.value.width} ${n.value.height}`,
            width: "100%"
          }, [
            c("defs", null, [
              c("linearGradient", {
                x1: "0%",
                y1: "0%",
                x2: "100%",
                y2: "0%",
                id: `sparkbar_gradient_${i}_${S.value}`
              }, [
                c("stop", {
                  offset: "0%",
                  "stop-color": s(b)(s(ue)(l.color, 0.03), 100 - e.value.style.bar.gradient.intensity)
                }, null, 8, de),
                c("stop", {
                  offset: "100%",
                  "stop-color": l.color
                }, null, 8, pe)
              ], 8, ce)
            ]),
            c("rect", {
              height: n.value.height,
              width: n.value.width,
              x: 0,
              y: 0,
              fill: s(b)(e.value.style.gutter.backgroundColor, e.value.style.gutter.opacity),
              rx: n.value.height / 2
            }, null, 8, fe),
            c("rect", {
              height: n.value.height,
              width: n.value.width * N(l),
              x: 0,
              y: 0,
              fill: e.value.style.bar.gradient.underlayerColor,
              rx: n.value.height / 2
            }, null, 8, ye),
            c("rect", {
              height: n.value.height,
              width: n.value.width * N(l),
              x: 0,
              y: 0,
              fill: e.value.style.bar.gradient.show ? `url(#sparkbar_gradient_${i}_${S.value})` : l.color,
              rx: n.value.height / 2
            }, null, 8, me)
          ], 8, ve))
        ], 12, ie)) : d("", !0)
      ], 64))), 256)),
      $.value ? d("", !0) : (r(), K(ne, {
        key: 2,
        config: {
          type: "sparkbar",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkbar: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 4));
  }
};
export {
  we as default
};
