import { useCssVars as Se, computed as g, openBlock as r, createElementBlock as v, createVNode as Fe, renderSlot as f, createElementVNode as k, normalizeStyle as _, pushScopeId as Ne, popScopeId as _e, ref as c, watch as j, onMounted as Pe, onBeforeUnmount as Te, createBlock as A, createCommentVNode as N, unref as C, createSlots as ze, withCtx as m, normalizeProps as q, guardReactiveProps as H, normalizeClass as se, Fragment as Ie, renderList as Ae, toDisplayString as ne, createTextVNode as Oe, nextTick as re } from "vue";
import { u as Me, Y as De, v as We, c as ue, t as Be, a as Ee, p as U, o as Re, e as ie, g as Ue, f as Ve, X as Ge, q as Le, r as Xe } from "./index-DI4DaxVG.js";
import { _ as je } from "./Title-Bk3h09h9.js";
import { u as qe, U as He } from "./usePrinter-D9bNzUQP.js";
import { d as Ye, t as Je, u as Ke } from "./useResponsive-NZB-WLRF.js";
import Qe from "./vue-ui-accordion-DsN9lxvc.js";
import { D as Ze } from "./DataTable-C-iU_7h7.js";
import et from "./BaseIcon-B9ZZ6wkT.js";
import { _ as de } from "./_plugin-vue_export-helper-CHgC5LLL.js";
import { u as ce } from "./useNestedProp-COsQo-tX.js";
const tt = (u) => (Ne("data-v-3fd7d274"), u = u(), _e(), u), at = { "data-html2canvas-ignore": "" }, ot = {
  key: 0,
  class: "reset-wrapper"
}, lt = {
  key: 1,
  class: "reset-wrapper"
}, st = { class: "mono-slicer" }, nt = /* @__PURE__ */ tt(() => /* @__PURE__ */ k("div", { class: "slider-track" }, null, -1)), rt = ["min", "max", "value"], ut = {
  __name: "MonoSlicer",
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 0
    },
    inputColor: {
      type: String,
      default: "#1A1A1A"
    },
    background: {
      type: String,
      default: "#FFFFFF"
    },
    borderColor: {
      type: String,
      default: "#FFFFFF"
    },
    selectColor: {
      type: String,
      default: "#4A4A4A"
    },
    textColor: {
      type: String,
      default: "#1A1A1A"
    },
    useResetSlot: {
      type: Boolean,
      default: !1
    },
    value: {
      type: Number,
      default: 0
    },
    source: {
      type: Number,
      default: 0
    }
  },
  emits: ["update:value", "reset"],
  setup(u, { emit: O }) {
    const s = u;
    Se((b) => ({
      "90ad3208": V.value,
      "4f9eef70": T.value,
      "6e07ae3e": P.value,
      "2fd430a0": u.selectColor,
      "6b8169a4": w.value
    }));
    const V = g(() => s.inputColor), w = g(() => s.background), P = g(() => `${s.selectColor}33`), T = g(() => s.borderColor);
    function z() {
      O("reset");
    }
    const x = g(() => {
      const b = s.max - s.min, y = 0, $ = (s.value - s.min) / b * 100;
      return {
        left: `${y}%`,
        width: `${$ - y}%`,
        background: s.selectColor
      };
    });
    return (b, y) => (r(), v("div", at, [
      u.value !== u.source ? (r(), v("div", ot, [
        u.useResetSlot ? f(b.$slots, "reset-action", {
          key: 1,
          reset: z
        }, void 0, !0) : (r(), v("button", {
          key: 0,
          "data-cy-reset": "",
          tabindex: "0",
          role: "button",
          class: "vue-data-ui-refresh-button",
          onClick: z
        }, [
          Fe(et, {
            name: "refresh",
            stroke: u.textColor
          }, null, 8, ["stroke"])
        ]))
      ])) : (r(), v("div", lt)),
      k("div", st, [
        nt,
        k("div", {
          class: "range-highlight",
          style: _(x.value)
        }, null, 4),
        k("input", {
          type: "range",
          min: u.min,
          max: u.max,
          value: Number(u.value),
          onInput: y[0] || (y[0] = ($) => O("update:value", Number($.target.value)))
        }, null, 40, rt)
      ])
    ]));
  }
}, it = /* @__PURE__ */ de(ut, [["__scopeId", "data-v-3fd7d274"]]), ct = ["id"], dt = ["xmlns", "viewBox"], vt = ["transform"], ht = ["fill", "font-weight", "x", "y", "font-size", "transform"], mt = {
  key: 3,
  class: "vue-data-ui-watermark"
}, ft = ["innerHTML"], gt = {
  __name: "vue-ui-word-cloud",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: [Array, String],
      default() {
        return [];
      }
    }
  },
  setup(u, { expose: O }) {
    const s = u, { vue_ui_word_cloud: V } = Me(), w = g({
      get() {
        return !!s.dataset && s.dataset.length;
      },
      set(t) {
        return t;
      }
    }), P = c(typeof s.dataset == "string" ? De(s.dataset) : s.dataset.map((t) => ({
      ...t,
      value: We(t.value)
    }))), T = c(ue()), z = c(0), x = c(null), b = c(null), y = c(0), $ = c(0), e = g({
      get: () => Y(),
      set: (t) => t
    });
    function Y() {
      const t = ce({
        userConfig: s.config,
        defaultConfig: V
      });
      return t.theme ? {
        ...ce({
          userConfig: Be.vue_ui_word_cloud[t.theme] || s.config,
          defaultConfig: t
        }),
        customPalette: Ee[t.theme] || U
      } : t;
    }
    j(() => s.config, (t) => {
      e.value = Y(), K(), y.value += 1, $.value += 1, h.value = e.value.style.chart.width;
    }, { deep: !0 });
    const J = c(null), h = c(e.value.style.chart.width), n = c({
      width: h.value,
      height: e.value.style.chart.height / e.value.style.chart.height * h.value,
      maxFontSize: e.value.style.chart.words.maxFontSize,
      minFontSize: e.value.style.chart.words.minFontSize
    }), ve = Je(() => {
      const { width: t, height: o } = Ke({
        chart: x.value,
        title: e.value.style.chart.title.text ? b.value : null,
        slicer: e.value.style.chart.zoom.show && J.value
      });
      n.value.width = t, n.value.height = o, re(G);
    });
    j(() => h.value, () => {
      he();
    });
    const he = Ye(() => {
      n.value.width = Number(h.value), n.value.height = e.value.style.chart.height / e.value.style.chart.height * Number(h.value), G();
    }, 10);
    function me() {
      h.value = e.value.style.chart.width;
    }
    const M = c(null);
    Pe(() => {
      K();
    });
    function K() {
      Re(s.dataset) ? ie({
        componentName: "VueUiWordCloud",
        type: "dataset"
      }) : P.value.forEach((t, o) => {
        Ue({
          datasetObject: t,
          requiredAttributes: ["name", "value"]
        }).forEach((a) => {
          w.value = !1, ie({
            componentName: "VueUiWordCloud",
            type: "datasetSerieAttribute",
            property: a,
            index: o
          });
        });
      }), e.value.responsive && (M.value = new ResizeObserver(ve), M.value.observe(x.value.parentNode));
    }
    Te(() => {
      M.value && M.value.disconnect();
    });
    const { isPrinting: Q, isImaging: Z, generatePdf: ee, generateImage: te } = qe({
      elementId: `wordCloud_${T.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-word-cloud"
    }), D = c({
      showTable: e.value.table.show
    });
    function fe(t, o, a = "Arial") {
      const l = document.createElement("canvas").getContext("2d");
      return l.font = `${o}px ${e.value.style.chart.words.bold ? "bold" : "normal"} ${a}`, {
        width: l.measureText(t).width + e.value.style.chart.words.proximity,
        height: o
      };
    }
    function ge(t, o) {
      return t.x < o.x + o.width && t.x + t.width > o.x && t.y < o.y + o.height && t.y + t.height > o.y;
    }
    function ye(t, o, a) {
      const i = [], l = { x: -o / 2, y: -a / 2, width: o, height: a }, d = 0, S = 0;
      return t.forEach((F) => {
        let L = !1;
        for (let R = 0; R < Math.max(o, a) / 2 && !L; R += e.value.style.chart.words.packingWeight)
          for (let X = 0; X < 360 && !L; X += e.value.style.chart.words.packingWeight) {
            const le = X * Math.PI / 180, Ce = d + R * Math.cos(le) - F.width / 2, ke = S + R * Math.sin(le) - F.height / 2, p = { ...F, x: Ce, y: ke }, we = p.x >= l.x && p.y >= l.y && p.x + p.width <= l.x + l.width && p.y + p.height <= l.y + l.height, xe = i.some(($e) => ge(p, $e));
            we && !xe && (i.push(p), L = !0);
          }
      }), i;
    }
    const I = c([]);
    j(() => s.dataset, G, { immediate: !0 });
    function G() {
      const t = P.value.map((l) => l.value), o = Math.max(...t), a = Math.min(...t), i = P.value.map((l, d) => {
        const S = (l.value - a) / (o - a) * (n.value.maxFontSize - n.value.minFontSize) + n.value.minFontSize, F = fe(l.name, S);
        return {
          ...l,
          id: ue(),
          fontSize: S,
          width: F.width,
          height: F.height,
          color: e.value.style.chart.words.usePalette ? e.value.customPalette[d] || e.value.customPalette[d % e.value.customPalette.length] || U[d] || U[d % U.length] : e.value.style.chart.words.color
        };
      });
      I.value = ye(i, n.value.width, n.value.height).sort((l, d) => d.fontSize - l.fontSize);
    }
    const W = g(() => {
      const t = I.value.map((a) => ({
        name: a.name,
        color: a.color
      })), o = I.value.map((a) => a.value);
      return { head: t, body: o };
    });
    function ae() {
      re(() => {
        const t = W.value.head.map((i, l) => [[
          i.name
        ], [W.value.body[l]]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], [e.value.table.columnNames.value]]].concat(t), a = Le(o);
        Xe({ csvContent: a, title: e.value.style.chart.title.text || "vue-ui-word-cloud" });
      });
    }
    const B = g(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value
      ], o = W.value.head.map((l, d) => {
        const S = Ve({ p: e.value.table.td.prefix, v: W.value.body[d], s: e.value.table.td.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: l.color,
            name: l.name
          },
          S
        ];
      }), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: o,
        config: a
      };
    }), E = c(!1);
    function pe(t) {
      E.value = t, z.value += 1;
    }
    function be() {
      return I.value;
    }
    function oe() {
      D.value.showTable = !D.value.showTable;
    }
    return O({
      getData: be,
      generateCsv: ae,
      generatePdf: ee,
      generateImage: te,
      toggleTable: oe
    }), (t, o) => (r(), v("div", {
      class: "vue-ui-word-cloud",
      ref_key: "wordCloudChart",
      ref: x,
      id: `wordCloud_${T.value}`,
      style: _(`width: 100%; font-family:${e.value.style.fontFamily};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.style.chart.title.text ? (r(), v("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: b,
        style: _(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:24px`)
      }, [
        (r(), A(je, {
          key: `title_${y.value}`,
          config: {
            title: {
              ...e.value.style.chart.title
            },
            subtitle: {
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : N("", !0),
      e.value.userOptions.show && w.value ? (r(), A(He, {
        ref: "details",
        key: `user_option_${z.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: C(Q),
        isImaging: C(Z),
        uid: T.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: E.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: x.value,
        onToggleFullscreen: pe,
        onGeneratePdf: C(ee),
        onGenerateCsv: ae,
        onGenerateImage: C(te),
        onToggleTable: oe
      }, ze({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            f(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            f(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            f(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            f(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: a, isFullscreen: i }) => [
            f(t.$slots, "optionFullscreen", q(H({ toggleFullscreen: a, isFullscreen: i })), void 0, !0)
          ]),
          key: "4"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : N("", !0),
      w.value ? (r(), v("svg", {
        key: 2,
        class: se({ "vue-data-ui-fullscreen--on": E.value, "vue-data-ui-fulscreen--off": !E.value }),
        xmlns: C(Ge),
        viewBox: `0 0 ${n.value.width <= 0 ? 10 : n.value.width} ${n.value.height <= 0 ? 10 : n.value.height}`,
        style: _(`overflow:visible;background:${e.value.style.chart.backgroundColor};`)
      }, [
        k("g", {
          transform: `translate(${(n.value.width <= 0 ? 10 : n.value.width) / 2}, ${(n.value.height <= 0 ? 10 : n.value.height) / 2})`
        }, [
          (r(!0), v(Ie, null, Ae(I.value, (a, i) => (r(), v("g", null, [
            (r(), v("text", {
              fill: a.color,
              "font-weight": e.value.style.chart.words.bold ? "bold" : "normal",
              key: i,
              x: a.x,
              y: a.y,
              "font-size": a.fontSize,
              transform: `translate(${a.width / 2}, ${a.height / 2})`,
              style: _(`animation-delay:${i * e.value.animationDelayMs}ms !important`),
              class: se({ animated: e.value.useCssAnimation }),
              "text-anchor": "middle",
              "dominant-baseline": "middle"
            }, ne(a.name), 15, ht))
          ]))), 256))
        ], 8, vt),
        f(t.$slots, "svg", {
          svg: { height: n.value.height, width: n.value.width }
        }, void 0, !0)
      ], 14, dt)) : N("", !0),
      t.$slots.watermark ? (r(), v("div", mt, [
        f(t.$slots, "watermark", q(H({ isPrinting: C(Q) || C(Z) })), void 0, !0)
      ])) : N("", !0),
      k("div", {
        ref_key: "chartSlicer",
        ref: J,
        style: _(`width:100%;background:${e.value.style.chart.backgroundColor}`),
        "data-html2canvas-ignore": ""
      }, [
        e.value.style.chart.zoom.show ? (r(), A(it, {
          key: 0,
          value: h.value,
          "onUpdate:value": o[0] || (o[0] = (a) => h.value = a),
          min: 100,
          max: e.value.style.chart.width * 3,
          textColor: e.value.style.chart.color,
          inputColor: e.value.style.chart.zoom.color,
          selectColor: e.value.style.chart.zoom.highlightColor,
          useResetSlot: e.value.style.chart.zoom.useResetSlot,
          background: e.value.style.chart.zoom.color,
          borderColor: e.value.style.chart.backgroundColor,
          source: e.value.style.chart.width,
          onReset: me
        }, {
          "reset-action": m(({ reset: a }) => [
            f(t.$slots, "reset-action", q(H({ reset: a })), void 0, !0)
          ]),
          _: 3
        }, 8, ["value", "max", "textColor", "inputColor", "selectColor", "useResetSlot", "background", "borderColor", "source"])) : N("", !0)
      ], 4),
      w.value ? (r(), A(Qe, {
        key: 4,
        hideDetails: "",
        config: {
          open: D.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (r(), A(Ze, {
            key: `table_${$.value}`,
            colNames: B.value.colNames,
            head: B.value.head,
            body: B.value.body,
            config: B.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[1] || (o[1] = (a) => D.value.showTable = !1)
          }, {
            th: m(({ th: a }) => [
              k("div", {
                innerHTML: a,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, ft)
            ]),
            td: m(({ td: a }) => [
              Oe(ne(a.name || a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : N("", !0)
    ], 12, ct));
  }
}, Nt = /* @__PURE__ */ de(gt, [["__scopeId", "data-v-c72337c3"]]);
export {
  Nt as default
};
