import { useCssVars as _e, computed as c, ref as u, watch as pe, onMounted as $e, onBeforeUnmount as Ce, openBlock as s, createElementBlock as o, normalizeStyle as h, createBlock as E, createCommentVNode as p, unref as y, createSlots as xe, withCtx as z, renderSlot as $, normalizeProps as K, guardReactiveProps as Q, normalizeClass as L, createElementVNode as we, Fragment as b, renderList as O, toDisplayString as be } from "vue";
import { u as Oe, c as Pe, t as Ae, a as Ie, p as Z, b as Fe, o as Ee, e as ee, g as ze, X as Le } from "./index-DI4DaxVG.js";
import { t as Se, u as Ne } from "./useResponsive-NZB-WLRF.js";
import { _ as Re } from "./Title-Bk3h09h9.js";
import { u as Te, U as Me } from "./usePrinter-D9bNzUQP.js";
import je from "./vue-ui-skeleton-DH4t1hrL.js";
import { u as te } from "./useNestedProp-COsQo-tX.js";
import { _ as Be } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ge = ["id"], Ue = ["xmlns", "viewBox"], De = ["cx", "cy", "r", "stroke", "stroke-width"], Ve = { key: 0 }, We = ["stroke", "d", "stroke-width"], Xe = { key: 1 }, Ye = ["stroke", "x1", "x2", "y1", "y2"], qe = ["text-anchor", "transform", "x", "y", "onClick", "font-weight", "font-size", "fill"], He = ["cx", "cy", "fill", "onClick", "r"], Je = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Ke = {
  __name: "vue-ui-relation-circle",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(le, { expose: re }) {
    const d = le;
    _e((e) => ({
      "7995534c": ue.value,
      "31095f2b": ie.value,
      "7c93c1cd": oe.value
    }));
    const { vue_ui_relation_circle: se } = Oe(), P = c(() => !!d.dataset && Object.keys(d.dataset).length), k = u(Pe()), S = u(0), C = u(null), N = u(null), R = u(0), l = c({
      get: () => T(),
      set: (e) => e
    });
    function T() {
      const e = te({
        userConfig: d.config,
        defaultConfig: se
      });
      return e.theme ? {
        ...te({
          userConfig: Ae.vue_ui_relation_circle[e.theme] || d.config,
          defaultConfig: e
        }),
        customPalette: Ie[e.theme] || Z
      } : e;
    }
    pe(() => d.config, (e) => {
      l.value = T(), D(), R.value += 1;
    }, { deep: !0 });
    const { isPrinting: M, isImaging: j, generatePdf: B, generateImage: G } = Te({
      elementId: `relation_circle_${k.value}`,
      fileName: l.value.style.title.text || "vue-ui-relation-circle"
    }), U = c(() => Fe(l.value.customPalette)), f = u([]), m = u([]), n = u({}), v = u([]), ne = u(0), A = c(() => d.dataset.slice(0, l.value.style.limit)), I = u(l.value.style.size), a = u({
      height: l.value.style.size,
      width: l.value.style.size
    }), g = c({
      get() {
        return I.value * l.value.style.circle.radiusProportion;
      },
      set(e) {
        return e;
      }
    }), ae = c(() => l.value.style.links.curved), ie = c(() => `${l.value.style.animation.speedMs}ms`), ue = c(() => g.value * 2), oe = c(() => g.value * 4), x = u(null);
    $e(() => {
      D(), document.getElementById(`relation_circle_${k.value}`).addEventListener("click", V);
    });
    function D() {
      if (Ee(d.dataset) ? ee({
        componentName: "VueUiRelationCircle",
        type: "dataset"
      }) : d.dataset.forEach((e, r) => {
        ze({
          datasetObject: e,
          requiredAttributes: ["id", "label", "relations", "weights"]
        }).forEach((t) => {
          ee({
            componentName: "VueUiRelationCircle",
            type: "datasetSerieAttribute",
            property: t,
            index: r
          });
        });
      }), l.value.responsive) {
        const e = Se(() => {
          const { width: r, height: t } = Ne({
            chart: C.value,
            title: l.value.style.title.text ? N.value : null
          });
          I.value = Math.min(r, t), a.value.width = r, a.value.height = t, g.value = I.value * l.value.style.circle.radiusProportion, f.value = [], m.value = [], W(), X();
        });
        x.value = new ResizeObserver(e), x.value.observe(C.value.parentNode);
      } else
        f.value = [], m.value = [], W(), X();
    }
    Ce(() => {
      document.getElementById(`relation_circle_${k.value}`).removeEventListener("click", V), x.value && x.value.disconnect();
    });
    function V(e) {
      const r = e.target;
      r && Array.from(r.classList).includes("vue-ui-user-options") || r && Array.from(r.classList).includes("vue-ui-user-options-summary") || r && Array.from(r.classList).includes("vue-data-ui-button") || r && Array.from(r.classList).includes("vue-ui-relation-circle-legend") || (n.value = {}, v.value = []);
    }
    function W() {
      const e = 6.28319 / A.value.length, r = 360 / A.value.length;
      let t = 0, i = 0;
      A.value.forEach((_, F) => {
        const me = g.value * Math.cos(t) + a.value.width / 2, ke = g.value * Math.sin(t) + a.value.height / 2 + l.value.style.circle.offsetY;
        f.value.push({ x: me, y: ke, ..._, color: _.color ? _.color : U.value[F] ? U.value[F] : Z[F], regAngle: i }), t += e, i += r;
      });
    }
    function X() {
      f.value.forEach((e) => {
        f.value.filter((t) => t.relations.includes(e.id)).forEach((t, i) => {
          m.value.push({
            weight: e.weights && e.weights[i] ? e.weights[i] : 1,
            relationId: `${e.id}_${t.id}`,
            x1: e.x,
            y1: e.y,
            x2: t.x,
            y2: t.y,
            colorSource: e.color,
            colorTarget: t.color,
            ...e
          });
        });
      });
    }
    const ce = c(() => Math.max(...m.value.map((e) => e.weight)));
    function de(e) {
      return Object.hasOwn(n.value, "x") ? v.value.includes(e.id) ? "opacity:1" : "opacity:0.1" : "opacity:1";
    }
    function Y(e) {
      return Object.hasOwn(n.value, "x") ? e.colorTarget : e.colorSource;
    }
    function q(e) {
      return Object.hasOwn(n.value, "x") ? v.value.includes(e.id) && e.relationId === `${e.id}_${n.value.id}` || e.relationId === `${n.value.id}_${e.id}` ? `opacity:1;stroke-width:${J(e)}` : "opacity: 0" : "opacity: 1";
    }
    function ve(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? "end" : "start";
    }
    function fe(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? e.x - 5 : e.x + 5;
    }
    function ge(e) {
      return Object.hasOwn(n.value, "x") ? n.value.id === e.id || v.value.includes(e.id) ? "opacity:1" : "opacity:0.2" : "opacity:1";
    }
    function he(e) {
      return e.regAngle > 90 && e.regAngle < 270 ? `rotate(${e.regAngle + 180},${e.x},${e.y})` : `rotate(${e.regAngle},${e.x},${e.y})`;
    }
    function H(e) {
      ne.value = 360 - e.regAngle, n.value.id && e.id === n.value.id ? (n.value = {}, v.value = []) : (n.value = e, v.value = [...e.relations]);
    }
    function J(e) {
      return e.weight / ce.value * l.value.style.links.maxWidth;
    }
    const w = u(!1);
    function ye(e) {
      w.value = e, S.value += 1;
    }
    return re({
      generatePdf: B,
      generateImage: G
    }), (e, r) => (s(), o("div", {
      ref_key: "relationCircleChart",
      ref: C,
      class: "vue-ui-relation-circle",
      style: h(`width:100%;background:${l.value.style.backgroundColor};text-align:center;${l.value.responsive ? "height: 100%" : ""}`),
      id: `relation_circle_${k.value}`
    }, [
      l.value.style.title.text ? (s(), o("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: N,
        style: h(`width:100%;background:${l.value.style.backgroundColor}`)
      }, [
        (s(), E(Re, {
          key: `title_${R.value}`,
          config: {
            title: {
              cy: "relation-div-title",
              ...l.value.style.title
            },
            subtitle: {
              cy: "relation-div-subtitle",
              ...l.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : p("", !0),
      l.value.userOptions.show && P.value ? (s(), E(Me, {
        ref: "details",
        key: `user_options_${S.value}`,
        backgroundColor: l.value.style.backgroundColor,
        color: l.value.style.color,
        isPrinting: y(M),
        isImaging: y(j),
        uid: k.value,
        hasPdf: l.value.userOptions.buttons.pdf,
        hasImg: l.value.userOptions.buttons.img,
        hasFullscreen: l.value.userOptions.buttons.img,
        hasXls: !1,
        isFullscreen: w.value,
        titles: { ...l.value.userOptions.buttonTitles },
        chartElement: C.value,
        onToggleFullscreen: ye,
        onGeneratePdf: y(B),
        onGenerateImage: y(G)
      }, xe({ _: 2 }, [
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: z(() => [
            $(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: z(() => [
            $(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: z(({ toggleFullscreen: t, isFullscreen: i }) => [
            $(e.$slots, "optionFullscreen", K(Q({ toggleFullscreen: t, isFullscreen: i })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : p("", !0),
      P.value ? (s(), o("svg", {
        key: 2,
        xmlns: y(Le),
        class: L([{ "vue-data-ui-fullscreen--on": w.value, "vue-data-ui-fulscreen--off": !w.value }, "relation-circle"]),
        viewBox: `0 0 ${a.value.width <= 0 ? 10 : a.value.width} ${a.value.height <= 0 ? 10 : a.value.height}`,
        width: "100%",
        style: h(`user-select:none; background:${l.value.style.backgroundColor}`)
      }, [
        we("circle", {
          cx: (a.value.width <= 0 ? 1e-4 : a.value.width) / 2,
          cy: (a.value.height <= 0 ? 1e-4 : a.value.height) / 2 + l.value.style.circle.offsetY,
          r: g.value <= 0 ? 1e-4 : g.value,
          stroke: l.value.style.circle.stroke,
          "stroke-width": l.value.style.circle.strokeWidth,
          fill: "transparent",
          class: "main-circle"
        }, null, 8, De),
        ae.value ? (s(), o("g", Ve, [
          (s(!0), o(b, null, O(m.value, (t, i) => (s(), o("path", {
            key: `relation_${i}`,
            style: h(q(t)),
            stroke: Y(t),
            class: L(["relation", { "vue-ui-relation-circle-selected": n.value.hasOwnProperty("id") && v.value.includes(t.id) }]),
            d: `M${t.x1},${t.y1} C${t.x1},${t.y1} ${a.value.width / 2},${a.value.height / 2 + l.value.style.circle.offsetY} ${t.x2},${t.y2}`,
            fill: "none",
            "stroke-width": J(t),
            "stroke-linecap": "round"
          }, null, 14, We))), 128))
        ])) : (s(), o("g", Xe, [
          (s(!0), o(b, null, O(m.value, (t, i) => (s(), o("line", {
            key: `relation_${i}`,
            stroke: Y(t),
            style: h(q(t)),
            x1: t.x1,
            x2: t.x2,
            y1: t.y1,
            y2: t.y2,
            class: L({ "vue-ui-relation-circle-selected": n.value.hasOwnProperty("id") && v.value.includes(t.id) }),
            "stroke-linecap": "round"
          }, null, 14, Ye))), 128))
        ])),
        (s(!0), o(b, null, O(f.value, (t, i) => (s(), o("text", {
          key: `plot_text_${i}`,
          "text-anchor": ve(t),
          transform: he(t),
          x: fe(t),
          y: t.y + 5,
          onClick: (_) => H(t),
          class: "vue-ui-relation-circle-legend",
          "transform-origin": "start",
          "font-weight": n.value.id === t.id ? "900" : "400",
          style: h(`font-family:${l.value.style.fontFamily};${ge(t)}`),
          "font-size": l.value.style.labels.fontSize,
          fill: l.value.style.labels.color
        }, be(t.label), 13, qe))), 128)),
        (s(!0), o(b, null, O(f.value, (t, i) => (s(), o("circle", {
          cx: t.x,
          cy: t.y,
          key: `plot_${i}`,
          style: h(de(t)),
          class: "vue-ui-relation-circle-plot",
          fill: l.value.style.plot.color,
          onClick: (_) => H(t),
          r: l.value.style.plot.radius
        }, null, 12, He))), 128)),
        $(e.$slots, "svg", { svg: a.value }, void 0, !0)
      ], 14, Ue)) : p("", !0),
      e.$slots.watermark ? (s(), o("div", Je, [
        $(e.$slots, "watermark", K(Q({ isPrinting: y(M) || y(j) })), void 0, !0)
      ])) : p("", !0),
      P.value ? p("", !0) : (s(), E(je, {
        key: 4,
        config: {
          type: "relationCircle",
          style: {
            backgroundColor: l.value.style.backgroundColor,
            relationCircle: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, Ge));
  }
}, at = /* @__PURE__ */ Be(Ke, [["__scopeId", "data-v-1d0ed086"]]);
export {
  at as default
};
